window.addEventListener("DOMContentLoaded",toggles);

function toggles() {
	var tHandles = document.querySelectorAll(".t-handle"),
		isDown = false,
		isAtEdge = false,
		eX = 0,
		down = function(e) {
			isDown = true;
			let parent = this.parentNode;
			eX = e.pageX - parent.offsetLeft;
		},
		move = function(e) {
			if (isDown) {
				let parent = this.parentNode;
			    eX = e.pageX - parent.offsetLeft;
				
				// keep within movable room
				if (eX > parent.offsetWidth / 4 && eX < parent.offsetWidth - this.offsetWidth / 2) {
					this.style.left = (eX - parent.offsetWidth / 4) + "px";
					this.nextSibling.style.width = (parent.offsetWidth / 2) + (eX - parent.offsetWidth / 4) + "px";
		            isAtEdge = false;
					
				// at left edge
				} else if (eX < parent.offsetWidth / 4) {
					parent.previousSibling.checked = false;
		            isAtEdge = true;
					
				// at right edge
				} else if (eX > parent.offsetWidth - this.offsetWidth / 2) {
					parent.previousSibling.checked = true;
		            isAtEdge = true;
				}
			}
		},
		up = function(e) {
			isDown = false;
			let parent = this.parentNode;
			this.style = "";
			this.nextSibling.style = "";
			
		},
		stopCheckUndo = function(e) {
			// prevent reverting of state after hitting edge
			if (isAtEdge) {
				isAtEdge = false;
				e.preventDefault();
		        return false;
			}
		};
	
	// add functions to switches
	var isMobile = "ontouchstart" in document.documentElement;
	for (var t in tHandles) {
		if (+t < tHandles.length) {
			tHandles[t].parentNode.addEventListener("click",stopCheckUndo);
			tHandles[t].addEventListener(isMobile ? "touchstart" : "mousedown",down);
			tHandles[t].addEventListener(isMobile ? "touchend" : "mouseup",up);
			tHandles[t].addEventListener(isMobile ? "touchmove" : "mousemove",move);
			tHandles[t].addEventListener(isMobile ? "touchleave" : "mouseout", up);
		}
	}
}